#include <windows.h>
#include <string.h>
#include <commctrl.h>
#include "AVRdb.h"

TCITEM tci;
DWORD fsih;
HFONT hFont;
LPNMHDR lpn;
HANDLE hFile;
HINSTANCE hInst;
OPENFILENAME ofn;
INITCOMMONCONTROLSEX icx;
int csel, xsel, ctab, tnum, temp, scrx, scry, chip = 354, cpdi = 274, cupd = 321, winx = 459, winy = 469; // liczba ukadw w bazie, szeroko/wysoko gwnego okna programu
HWND hWnd, hBut0, hBut1, hBut2, hBut3, hBut4, hBut5, hLis0, hWin0, hWin1, hWin2, hTab0, hTemp,
hFub0, hFub1, hFub2, hFub3, hFub4, hFub5, hFub6, hFub7, hFuw0, hFuw1, hFuw2, hFuw3, hFuw4, hFuw5, hFuw6, hFuw7,
hFun0, hFun1, hFun2, hFun3, hFun4, hFun5, hFun6, hFun7, hFuv0, hFuv1, hFuv2;
HWND *xFub[] = {&hFub7, &hFub6, &hFub5, &hFub4, &hFub3, &hFub2, &hFub1, &hFub0},
*xFuw[] = {&hFuw7, &hFuw6, &hFuw5, &hFuw4, &hFuw3, &hFuw2, &hFuw1, &hFuw0};
char fdef[1], scla[] = "AVRdbClass", snam[] = "AVRdb 1.0", fnam[MAX_PATH], smsg[260], smsh[410], smsi[660], smsj[3230],
sver[] = "AVRdb 1.0 (21.06.2020)\nCreated by Roman Brenski (RomanWorkshop)\nusing Open Watcom 1.9 compiler.\nThis program is freeware.\n\nDatabase: 354 chips\n\nAll informations are based on datasheets and\nAVR/Atmel Studio definition files (XML/ATDF).",
info[] = "ISP = In-System Programming\nTPI = Tiny Programming Interface\nHVSP = High Voltage Serial Programming\nLVPP = Low Voltage Parallel Programming\nHVPP = High Voltage Parallel Programming\nPDI = Program and Debug Interface\nUPDI = Unified Program and Debug Interface\n\ndW = debugWire\nJTAG = Joint Test Action Group";
char *cfus, *nap[] = {"AT90", "ATtiny", "ATmega", "ATxmega"}, *fus[] = {"Low", "High", "Extended", "Lock Bits"},
*txt[] = {"Page size 0 means that memory is accessed without paging (byte-by-byte).\r\n\r\n",
"This device doesn't support ReadBack (0x53) instruction of the ISP interface.\r\n",
"This device doesn't allow programming of all fuse bits via the ISP interface.\r\n\r\n",
"This device doesn't allow programming of SPIEN fuse bit via the ISP interface.\r\n\r\n",
"When both lock bits are programmed (Lock mode 3), device signature can't be read\r\nvia the low-voltage serial ISP interface (reading signature will return 0x000102).\r\n\r\n",
"This device has internal ADC converter (",
"This device has internal DAC converter (",
"This device has internal full speed USB 2.0 controller.\r\n",
"This device has internal CAN 2.0A/B controller.\r\n",
"This device has internal LIN 1.3/2.1 controller.\r\n",
"This device has internal DMA controller (",
"This device has internal programmable logic module (",
"This device has internal memory check module (CRC-16",
"This device has internal high speed PLL oscillator (",
"This device has internal high speed PLL synthesizer (2322-2527 MHz).\r\n\r\n"};

// Dane wszystkich ukadw w bazie
char nax[] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2};
char *nam[] = {"S1200-4","S1200-12","S2313-4","S2313-10","S2323-10","LS2323-4","S2333-8","LS2333-4","S2343-10","LS2343-4","LS2343-1","S4414-4","S4414-8","S4433-8","LS4433-4","S4434-8","LS4434-4","S8515-4","S8515-8","C8534","VC8534","S8535-8","LS8535-4","CAN32","CAN64","CAN128","PWM1","PWM2","PWM2B","PWM3","PWM3B","PWM81","PWM161","PWM216","PWM316","USB82","USB162","USB646","USB647","USB1286","USB1287","4","5","9","10","11","11L","12","12L","12V","13","13A","13V","15L","20","22","22L","24","24A","24V","25","25V","26","26L","28L","28V","40","43U","44","44A","44V","45","45V","48","84","84A","84V","85","85V","87","88","102","104","167","261","261A","261V","441","461","461A","461V","828","841","861","861A","861V","1634","1634R","2313","2313A","2313V","4313","4HVD","8","8A","8L","8U2","8HVA","8HVD","16","16A","16L","16M1","16U2","16U4","16U4RC","16HVA","16HVA2","16HVB","32","32A","32L","32C1","32M1","32U2","32U4","32U4RC","32U6","32HVB","32HVE","32HVE2","48","48A","48V","48P","48PA","48PV","48PB","64","64A","64L","64C1","64M1","64HVE","64HVE2","64RFR2","88","88A","88V","88P","88PA","88PV","88PB","103","103L","128","128A","128L","128RFA1","128RFR2","161","161L","162","162V","163","163L","164","164A","164V","164P","164PA","164PV","165","165A","165V","165P","165PA","165PV","168","168A","168V","168P","168PA","168PV","168PB","169","169A","169V","169P","169PA","169PV","256RFR2","323","323L","324","324A","324V","324P","324PA","324PV","324PB","325","325A","325V","325P","325PA","325PV","328","328P","328PV","328PB","329","329A","329V","329P","329PA","329PV","406","603","603L","640","640V","644","644A","644V","644P","644PA","644PV","644RFR2","645","645A","645V","645P","649","649A","649V","649P","1280","1280V","1281","1281V","1284","1284P","1284RFR2","2560","2560V","2561","2561V","2564RFR2","2564RFR2 (rev.A)","3250","3250A","3250V","3250P","3250PA","3250PV","3290","3290A","3290V","3290P","3290PA","3290PV","6450","6450A","6450V","6450P","6490","6490A","6490V","6490P","8515","8515L","8535","8535L","8E5","16A4","16A4U","16C4","16D4","16E5","32A4","32A4U","32C3","32C4","32D3","32D4","32E5","64A1","64A1U","64A3","64A3U","64A4","64A4U","64B1","64B3","64C3","64D3","64D4","128A1","128A1U","128A3","128A3U","128A4","128A4U","128B1","128B3","128C3","128D3","128D4","192A3","192A3U","192C3","192D3","256A3","256A3U","256A3B","256A3BU","256C3","256D3","384C3","384D3","202","204","212","214","402","404","406","412","414","416","417","804","806","807","814","816","817","1604","1606","1607","1614","1616","1617","3216","3217","808","809","1608","1609","3208","3209","4808","4809"};
int fla[] = {64,64,128,128,128,128,128,128,128,128,128,256,256,256,256,256,256,512,512,512,512,512,512,2048,4096,8192,512,512,512,512,512,512,1024,1024,1024,512,1024,4096,4096,8192,8192,32,32,64,64,64,64,64,64,64,64,64,64,64,128,128,128,128,128,128,128,128,128,128,128,128,256,256,256,256,256,256,256,256,512,512,512,512,512,512,512,64,64,1024,128,128,128,256,256,256,256,512,512,512,512,512,1024,1024,128,128,128,256,256,512,512,512,512,512,512,1024,1024,1024,1024,1024,1024,1024,1024,1024,1024,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,256,256,256,256,256,256,256,4096,4096,4096,4096,4096,4096,4096,4096,512,512,512,512,512,512,512,8192,8192,8192,8192,8192,8192,8192,1024,1024,1024,1024,1024,1024,1024,1024,1024,1024,1024,1024,1024,1024,1024,1024,1024,1024,1024,1024,1024,1024,1024,1024,1024,1024,1024,1024,1024,1024,1024,16384,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2560,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,8192,8192,8192,8192,8192,8192,8192,16384,16384,16384,16384,16384,16384,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,2048,4096,4096,4096,4096,4096,4096,4096,4096,512,512,512,512,512,1024,1024,1024,1024,1024,2048,2048,2048,2048,2048,2048,2048,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,4096,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,8192,12288,12288,12288,12288,16384,16384,16384,16384,16384,16384,24576,24576,128,128,128,128,256,256,256,256,256,256,256,512,512,512,512,512,512,1024,1024,1024,1024,1024,1024,2048,2048,512,512,1024,1024,2048,2048,3072,3072};
char flp[] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,64,64,16,16,16,16,16,16,32,32,32,32,32,64,64,64,64,4,4,4,4,0,0,0,0,0,8,8,8,0,8,0,0,8,8,8,8,8,8,8,0,0,16,16,16,16,16,16,16,16,16,16,16,16,16,32,16,4,4,32,8,8,8,4,16,16,16,16,4,16,16,16,8,8,8,8,8,16,16,16,16,16,16,32,16,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,16,16,16,16,16,16,16,64,64,64,64,64,32,32,64,16,16,16,16,16,16,16,64,64,64,64,64,64,64,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,64,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,32,32,32,32,32,32,32,32,32,32,32,32,64,64,64,64,64,64,64,64,16,16,16,16,32,64,64,64,64,32,64,64,64,64,64,64,32,64,64,64,64,64,64,64,64,64,64,64,128,128,128,128,64,64,64,64,128,128,64,128,128,128,128,128,128,128,128,128,128,128,128,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,32,32,16,16,16,16,32,32,32,32};
int epr[] = {4,4,8,8,8,8,8,8,8,8,8,16,16,16,16,16,16,32,32,32,32,32,32,64,128,256,32,32,32,32,32,32,32,32,32,32,32,128,128,256,256,0,0,0,0,0,0,4,4,4,4,4,4,4,0,8,8,8,8,8,8,8,8,8,0,0,0,4,16,16,16,16,16,4,32,32,32,32,32,32,4,0,0,32,8,8,8,16,16,16,16,16,32,32,32,32,16,16,8,8,8,16,16,32,32,32,32,16,16,32,32,32,32,32,32,32,16,16,32,64,64,64,64,64,64,64,64,64,64,64,64,16,16,16,16,16,16,16,128,128,128,128,128,64,64,128,32,32,32,32,32,32,32,256,256,256,256,256,256,256,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,512,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,32,128,128,256,256,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,256,256,256,256,256,256,256,256,256,256,256,512,512,64,64,64,64,64,64,64,64,64,64,64,64,128,128,128,128,128,128,128,128,32,32,32,32,32,64,64,64,64,32,64,64,64,64,64,64,64,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,256,256,256,256,256,256,256,256,4,4,4,4,8,8,8,8,8,8,8,8,8,8,8,8,8,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16};
char epp[] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,1,1,2,1,1,1,1,1,1,1,0,0,2,2,2,2,2,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,1,1,1,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,16,16,8,8,8,8,16,16,16,16};
int sra[] = {0,0,8,8,8,8,8,8,8,8,8,16,16,8,8,16,16,32,32,16,16,32,32,128,256,256,32,32,32,32,32,16,64,64,64,32,32,256,256,512,512,2,2,2,2,0,0,0,0,0,4,4,4,0,8,8,8,8,8,8,8,8,8,8,0,0,16,16,16,16,16,16,16,16,32,32,32,32,32,32,32,2,2,32,8,8,8,16,16,16,16,32,32,32,32,32,64,64,8,8,8,16,32,64,64,64,32,32,32,64,64,64,64,32,80,80,32,64,64,128,128,128,128,128,64,160,160,160,128,256,256,32,32,32,32,32,32,32,256,256,256,256,256,256,256,512,64,64,64,64,64,64,64,256,256,256,256,256,1024,1024,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,2048,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,256,256,512,512,256,256,256,256,256,256,512,256,256,256,256,256,256,256,256,512,512,512,512,1024,1024,1024,512,512,512,512,2048,2048,128,128,128,128,128,128,128,128,128,128,128,128,256,256,256,256,256,256,256,256,32,32,32,32,64,128,128,128,128,128,256,256,256,256,256,256,256,256,256,256,256,256,256,256,256,256,256,256,512,512,512,512,512,512,512,512,512,512,512,1024,1024,1024,1024,1024,1024,1024,1024,1024,1024,2048,2048,8,8,8,8,16,16,16,16,16,16,16,32,32,32,32,32,32,64,64,64,128,128,128,128,128,64,64,128,128,256,256,384,384};
char six[] = {2,2,3,3,4,4,20,20,4,4,4,3,3,20,20,20,20,3,3,19,19,20,20,14,14,14,9,25,25,25,25,25,25,25,25,8,8,21,21,21,21,0,18,0,18,0,0,1,1,1,22,22,22,7,19,4,4,22,22,22,9,9,9,9,0,0,19,22,22,22,22,9,9,22,22,22,22,9,9,16,22,19,19,16,9,9,9,22,9,9,9,22,22,9,9,9,22,22,5,5,5,5,22,22,22,22,8,23,22,22,22,22,15,8,10,10,23,23,24,22,22,22,17,15,8,10,10,21,24,6,6,22,22,22,22,22,22,22,22,22,22,17,15,6,6,11,22,22,22,22,22,22,22,22,22,22,22,22,11,11,5,5,5,5,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,11,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,24,22,22,22,22,22,22,22,22,22,22,11,22,22,22,22,22,22,22,22,22,22,22,22,22,22,11,22,22,22,22,11,11,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,5,5,22,22,29,26,27,13,12,29,26,27,13,13,12,12,29,26,27,26,27,26,27,31,31,13,12,12,26,27,26,27,26,27,31,31,13,12,12,26,27,13,12,26,27,26,27,13,12,31,12,30,30,28,28,30,30,30,28,28,28,28,30,30,30,28,28,28,30,30,30,28,28,28,28,28,30,30,30,30,30,30,30,30};
int sig[] = {0x9001,0x9001,0x9101,0x9101,0x9102,0x9102,0x9105,0x9105,0x9103,0x9103,0x9103,0x9201,0x9201,0x9203,0x9203,0x9202,0x9202,0x9301,0x9301,0x9304,0x9304,0x9303,0x9303,0x9581,0x9681,0x9781,0x9383,0x9381,0x9383,0x9381,0x9383,0x9388,0x948B,0x9483,0x9483,0x9382,0x9482,0x9682,0x9682,0x9782,0x9782,0x8F0A,0x8F09,0x9008,0x9003,0x9004,0x9004,0x9005,0x9005,0x9005,0x9007,0x9007,0x9007,0x9006,0x910F,0x9106,0x9106,0x910B,0x910B,0x910B,0x9108,0x9108,0x9109,0x9109,0x9107,0x9107,0x920E,0x920C,0x9207,0x9207,0x9207,0x9206,0x9206,0x9209,0x930C,0x930C,0x930C,0x930B,0x930B,0x9387,0x9311,0x900C,0x900B,0x9487,0x910C,0x910C,0x910C,0x9215,0x9208,0x9208,0x9208,0x9314,0x9315,0x930D,0x930D,0x930D,0x9412,0x9412,0x910A,0x910A,0x910A,0x920D,0x9313,0x9307,0x9307,0x9307,0x9389,0x9310,0x9312,0x9403,0x9403,0x9403,0x9484,0x9489,0x9488,0x9488,0x940C,0x940E,0x940D,0x9502,0x9502,0x9502,0x9586,0x9584,0x958A,0x9587,0x9587,0x9588,0x9510,0x9513,0x9513,0x9205,0x9205,0x9205,0x920A,0x920A,0x920A,0x9210,0x9602,0x9602,0x9602,0x9686,0x9684,0x9610,0x9610,0xA602,0x930A,0x930A,0x930A,0x930F,0x930F,0x930F,0x9316,0x9701,0x9701,0x9702,0x9702,0x9702,0xA701,0xA702,0x9401,0x9401,0x9404,0x9404,0x9402,0x9402,0x940F,0x940F,0x940F,0x940A,0x940A,0x940A,0x9405,0x9410,0x9405,0x9407,0x9407,0x9407,0x9406,0x9406,0x9406,0x940B,0x940B,0x940B,0x9415,0x9405,0x9411,0x9405,0x9405,0x9405,0x9405,0xA802,0x9501,0x9501,0x9515,0x9515,0x9515,0x9508,0x9511,0x9508,0x9517,0x9505,0x9505,0x9505,0x950D,0x950D,0x950D,0x9514,0x950F,0x950F,0x9516,0x9503,0x9503,0x9503,0x950B,0x950B,0x950B,0x9507,0x9601,0x9601,0x9608,0x9608,0x9609,0x9609,0x9609,0x960A,0x960A,0x960A,0xA603,0x9605,0x9605,0x9605,0x960D,0x9603,0x9603,0x9603,0x960B,0x9703,0x9703,0x9704,0x9704,0x9706,0x9705,0xA703,0x9801,0x9801,0x9802,0x9802,0xA803,0xA802,0x9506,0x9506,0x9506,0x950E,0x950E,0x950E,0x9504,0x9504,0x9504,0x950C,0x950C,0x950C,0x9606,0x9606,0x9606,0x960E,0x9604,0x9604,0x9604,0x960C,0x9306,0x9306,0x9308,0x9308,0x9341,0x9441,0x9441,0x9443,0x9442,0x9445,0x9541,0x9541,0x9549,0x9544,0x954A,0x9542,0x954C,0x964E,0x964E,0x9642,0x9642,0x9646,0x9646,0x9652,0x9651,0x9649,0x964A,0x9647,0x974C,0x974C,0x9742,0x9742,0x9746,0x9746,0x974D,0x974B,0x9752,0x9748,0x9747,0x9744,0x9744,0x9751,0x9749,0x9842,0x9842,0x9843,0x9843,0x9846,0x9844,0x9845,0x9847,0x9123,0x9122,0x9121,0x9120,0x9227,0x9226,0x9225,0x9223,0x9222,0x9221,0x9220,0x9325,0x9324,0x9323,0x9322,0x9321,0x9320,0x9425,0x9424,0x9423,0x9422,0x9421,0x9420,0x9521,0x9522,0x9326,0x932A,0x9427,0x9426,0x9530,0x9531,0x9650,0x9651};
char fra[] = {4,12,4,10,10,4,8,4,10,4,1,4,8,8,4,8,4,4,8,1,1,8,4,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,12,12,12,12,6,2,8,4,1,20,20,10,1,12,8,4,20,20,10,20,10,16,8,4,1,12,8,20,20,10,20,10,12,20,20,10,20,10,16,12,12,12,16,20,20,10,16,20,20,10,20,16,20,20,10,12,12,20,20,10,20,4,16,16,8,16,4,4,16,16,8,16,16,16,16,4,4,8,16,16,8,16,16,16,16,16,16,8,15,15,20,20,10,20,20,10,20,16,16,8,16,16,15,15,16,20,20,10,20,20,10,20,6,4,16,16,8,16,16,8,4,16,8,8,4,20,20,10,20,20,10,16,16,8,16,16,8,20,20,10,20,20,10,20,16,16,8,16,16,8,16,8,4,20,20,10,20,20,10,20,16,20,8,20,20,10,20,20,10,20,16,20,8,20,20,10,1,6,4,16,8,20,20,10,20,20,10,16,16,16,8,16,16,16,8,16,16,8,16,8,20,20,16,16,8,16,8,16,16,16,20,8,20,20,10,16,20,8,20,20,10,16,20,8,20,16,20,8,20,16,8,16,8,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20};
char frb[] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
char via[] = {2,4,2,4,4,2,4,2,4,2,2,2,4,4,2,4,2,2,4,3,3,4,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,4,2,4,2,1,2,1,1,2,1,4,2,2,1,1,2,1,4,2,2,1,1,1,2,1,1,2,1,1,2,1,1,2,1,1,1,1,1,1,2,1,1,1,2,1,1,1,1,2,1,1,1,1,2,1,1,1,2,4,2,2,2,1,2,4,2,2,2,2,2,2,1,1,4,4,2,2,2,2,2,2,2,2,4,5,5,2,1,1,2,1,1,1,4,2,2,2,2,5,5,1,2,1,1,2,1,1,1,4,2,4,2,2,1,1,4,2,2,1,4,2,2,1,1,2,1,1,2,1,1,2,1,1,2,1,1,2,1,1,1,2,1,1,2,1,1,1,4,2,2,1,1,2,1,1,1,2,1,1,2,1,1,1,2,1,1,2,1,1,2,1,1,4,4,2,2,1,2,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,1,1,1,1,4,1,4,1,1,1,2,1,1,2,1,1,2,1,1,2,1,1,2,1,1,1,2,1,1,1,4,2,4,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
char vib[] = {7,0,7,0,0,7,0,7,0,7,7,7,0,0,7,0,7,7,0,3,3,0,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,8,8,8,8,0,7,0,7,8,7,8,8,7,8,0,7,7,8,8,7,8,5,7,7,8,8,8,7,8,8,7,8,8,7,8,8,7,8,8,8,8,8,8,7,8,8,7,7,8,8,7,7,7,8,8,8,8,7,8,8,8,1,5,7,7,7,8,1,5,7,7,7,7,7,7,8,8,0,5,7,7,7,7,7,7,7,7,0,0,0,7,8,8,7,8,8,8,5,7,7,7,7,0,0,8,7,8,8,7,8,8,8,0,7,5,7,7,8,8,0,7,7,8,0,7,7,8,8,7,8,8,7,8,8,7,8,8,7,8,8,7,8,8,8,7,8,8,7,8,8,8,0,7,7,8,8,7,8,8,8,7,8,8,7,8,8,8,7,8,8,7,8,8,7,8,8,0,0,7,7,8,7,8,8,7,8,8,8,7,8,8,8,7,8,8,8,7,8,7,8,8,8,8,5,8,5,8,8,8,7,8,8,7,8,8,7,8,8,7,8,8,7,8,8,8,7,8,8,8,5,7,5,7,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8};
char vma[] = {6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,9,5,5,5,5,5,5,5,5,9,9,18,5,5,5,5,5,5,5,5,5,18,27,27,5,5,5,5,5,5,5,5,5,5,5,5,27,27,3,5,5,5,5,5,5,5,5,3,5,5,5,3,3,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,3,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,25,5,3,5,5,5,5,5,5,5,5,3,5,5,5,5,5,5,5,5,5,5,5,5,5,5,3,5,5,5,5,3,3,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5};
char vmb[] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,5,5,5,5,5,5,5,5,0,0,0,5,5,5,5,5,5,5,5,5,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,0,0,6,5,5,5,5,5,5,5,5,6,5,5,5,6,6,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,5,6,5,5,5,5,5,5,5,5,6,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,5,5,5,5,6,6,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5};
char *fac[] = {"ISP/HVPP","ISP/HVSP","LVPP","ISP/HVPP/JTAG","ISP/HVPP/dW","TPI","HVSP","ISP/HVSP/dW","HVPP","ISP/LVPP/JTAG","HVPP/JTAG","PDI","PDI/JTAG","UPDI"};
char fax[] = {0,0,0,0,1,1,0,0,1,1,1,0,0,0,0,0,0,0,0,2,2,0,0,3,3,3,4,4,4,4,4,4,4,4,4,4,4,3,3,3,3,5,5,5,5,6,6,1,1,1,7,7,7,1,5,1,1,7,7,7,7,7,0,0,8,8,5,4,7,7,7,7,7,4,7,7,7,7,7,4,4,5,5,4,4,4,4,7,4,4,4,4,7,4,4,4,4,4,4,4,4,4,7,0,0,0,4,7,7,3,3,3,4,4,3,3,7,7,4,3,3,3,4,4,4,3,3,3,4,7,7,4,4,4,4,4,4,4,3,3,3,4,4,7,7,9,4,4,4,4,4,4,4,0,0,3,3,3,9,9,0,0,3,3,0,0,3,3,3,3,3,3,3,3,3,3,3,3,4,4,4,4,4,4,4,3,3,3,3,3,3,9,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,4,4,4,4,3,3,3,3,3,3,10,0,0,3,3,3,3,3,3,3,3,9,3,3,3,3,3,3,3,3,3,3,3,3,3,3,9,3,3,3,3,9,9,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,11,11,11,11,11,11,11,11,11,11,11,11,11,12,12,12,12,11,11,12,12,11,11,11,12,12,12,12,11,11,12,12,11,11,11,12,12,11,11,12,12,12,12,11,11,11,11,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13};
char *pac[] = {"DIP20/SOIC20/SSOP20","DIP20/SOIC20","DIP8/SOIC8","DIP28/TQFP32","DIP40/PLCC44/TQFP44","TQFP48","TQFP64/VQFN64","SOIC24/VQFN32","SOIC24","SOIC32/VQFN32","SOIC20/VQFN32","VQFN32","TQFP32/VQFN32","SOT23-6/UDFN8","DIP8/SOIC8/VDFN10/WQFN20","SOIC14/TSSOP14/VQFN20/UFBGA15/WLCSP12","DIP14/SOIC14/WQFN20","DIP14/SOIC14/VQFN20/WQFN20/UFBGA15","DIP8/SOIC8/WQFN20","DIP20/SOIC20/VQFN32","DIP28/TQFP32/VQFN32","SOIC20/TSSOP20/VQFN20","SOIC20/WQFN20","DIP8/SOIC8/TSSOP8/WQFN20","DIP28/TQFP32/VQFN28/VQFN32/UFBGA32","SOIC20/TSSOP20/VQFN32","SOIC8/UDFN8","SOIC14","SOIC20/TSSOP20/VQFN32/WQFN20","DIP20/SOIC20/TSSOP20/VQFN32","SOIC14/VQFN20/WQFN20","DIP20/SOIC20/WQFN20","DIP20/SOIC20/VQFN20/WQFN20","DRDFN18","TSOP28/LGA36","DIP40/TQFP44/VQFN44","TQFP44/VQFN44","TSSOP44","VQFN48","DIP28/TQFP32/VQFN28/VQFN32","VQFN64","TQFP64","DIP40/TQFP44","DIP40/TQFP44/VQFN44/DRQFN44/VFBGA49","DIP40/TQFP44/VQFN44/DRQFN44","TQFP64/VQFN64/DRQFN64","DIP28/TQFP32/QFN28/VQFN32/UFBGA32","LQFP48","TQFP100/TFBGA100/CBGA100","TQFP100","DIP40/PLCC44/TQFP44/VQFN44","TQFP32/VQFN32/UQFN32","TQFP44/VQFN44/VFBGA49","TQFP100/TFBGA100/VFBGA100/CBGA100","TQFP100/VFBGA100","SOIC8","SOIC20/VQFN20","VQFN24","SSOP28/TQFP32/VQFN32","TQFP48/UQFN48","DIP40/TQFP48/UQFN48"};
char pax[] = {0,0,1,1,2,2,3,3,2,2,2,4,4,3,3,4,4,4,4,5,5,4,4,6,6,6,7,8,8,9,9,10,10,8,9,11,12,6,6,6,6,13,13,13,13,2,2,2,2,2,14,14,14,2,15,2,2,16,17,16,18,18,19,19,20,20,21,22,16,17,16,23,23,24,16,17,16,18,18,25,24,26,27,28,19,29,19,30,19,29,19,12,30,19,29,19,22,22,31,32,31,32,33,20,20,20,12,34,33,35,35,35,12,12,36,36,34,34,37,35,35,35,12,12,12,36,36,6,37,34,38,39,24,39,39,24,39,12,6,6,6,12,12,34,38,40,20,24,20,20,24,20,12,41,41,6,6,6,40,40,4,4,35,35,42,42,35,43,35,44,43,35,6,45,6,6,45,6,20,24,20,20,46,20,12,6,45,6,45,45,45,40,42,42,35,43,35,35,43,35,36,6,6,6,6,6,6,39,39,20,12,6,6,6,6,6,6,47,41,41,48,48,35,35,35,35,35,35,38,6,6,6,6,6,6,6,6,48,48,6,6,35,35,38,48,48,6,6,38,38,49,49,49,49,49,49,49,49,49,49,49,49,49,49,49,49,49,49,49,49,50,50,50,50,51,52,52,52,52,51,52,52,6,52,6,52,51,53,53,6,6,36,52,54,6,6,6,52,53,53,6,6,36,52,54,6,6,6,52,6,6,6,6,6,6,6,6,6,6,6,6,55,27,55,27,55,27,56,55,27,56,57,27,56,57,27,56,57,27,56,57,27,56,57,56,57,58,5,58,5,58,59,58,60};
char cal[] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,2,2,2,1,1,0,0,1,1,1,2,2,4,4,1,1,1,1,1,1,1,2,2,1,1,1,1,2,2,1,1,1,1,1,1,1,1,4,1,1,1,6,4,1,1,1,6,6,1,2,1,2,1,4,4,4,1,22,1,4,4,4,1,1,1,1,22,22,24,4,4,4,1,1,1,1,1,1,24,22,24,1,1,1,1,1,1,1,4,4,4,1,1,22,24,1,1,1,1,1,1,1,1,0,0,4,4,4,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,20,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,4,4,4,4,15,13,22,12,9,15,13,22,12,12,9,9,15,13,22,13,22,13,22,12,12,12,9,9,13,22,13,22,13,22,12,12,12,9,9,13,22,12,9,13,22,13,22,12,9,12,9,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,10,10,10,10,10,10,10,10};
char f00[] = {20,20,21,21,22,22,23,23,20,20,11,21,21,23,23,21,21,21,21,0,0,21,21,2,2,2,2,2,2,2,2,2,2,2,2,8,8,8,8,8,8,24,24,24,24,25,25,9,9,9,1,1,1,10,26,11,11,2,2,2,2,2,3,3,27,27,26,2,2,2,2,2,2,4,2,2,2,2,2,2,4,29,29,2,2,2,2,7,2,2,2,4,7,2,2,2,7,7,5,2,5,2,12,6,6,6,8,12,12,6,6,6,2,8,8,13,12,12,14,6,6,6,2,2,8,8,13,8,14,15,15,2,2,2,2,2,2,2,6,6,6,2,2,15,15,2,2,2,2,2,2,2,2,16,16,6,6,6,2,2,17,17,2,2,18,18,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,19,19,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,28,16,16,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,6,6,6,6,0,30,30,0,0,0,30,30,0,0,0,0,0,30,30,30,30,30,30,0,0,0,0,0,30,30,30,30,30,30,0,0,0,0,0,30,30,0,0,30,30,30,30,0,0,0,0,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31};
char f01[] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,8,2,2,2,2,2,7,7,2,2,11,11,12,12,8,8,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,2,2,2,2,2,3,3,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,0,0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,4,4,4,4,13,5,5,5,11,0,13,6,6,6,7,11,8,8,0,14,15,6,6,6,7,7,11,8,8,8,15,16,16,2,2,2,2,2,2,2,6,6,6,7,7,16,16,8,2,2,2,2,2,2,2,0,0,6,6,6,8,8,0,0,8,8,17,17,8,8,8,8,8,8,8,8,8,8,8,8,2,2,2,2,2,2,2,8,8,8,8,8,8,8,18,18,8,8,8,8,8,8,8,8,8,8,8,8,8,7,7,7,7,8,8,8,8,8,8,19,0,0,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,9,9,10,10,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21};
char f02[] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,6,6,12,12,12,12,12,13,13,12,12,14,14,15,15,15,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,9,1,1,1,10,9,1,1,1,11,11,1,1,1,1,0,0,0,0,14,0,0,0,0,0,16,14,15,17,0,0,0,0,0,0,16,16,14,15,17,15,0,0,0,1,1,1,1,1,1,1,4,4,4,16,16,0,0,20,2,2,2,2,2,2,2,0,0,4,4,4,20,20,0,0,5,5,0,0,3,3,3,3,3,3,6,7,6,7,7,7,2,2,2,2,2,2,2,6,7,6,7,7,7,20,0,0,3,3,3,3,3,3,19,8,8,8,8,8,8,3,3,3,18,8,8,8,8,8,8,0,0,0,3,3,3,3,3,3,3,3,20,8,8,8,8,8,8,8,8,3,3,3,3,3,3,20,3,3,3,3,20,20,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,0,0,0,21,21,22,22,22,21,21,22,22,22,22,22,21,21,22,21,22,21,22,22,22,22,22,22,21,22,21,22,21,22,22,22,22,22,22,21,22,22,22,21,22,21,22,22,22,22,22,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23};
char f03[] = {3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,5,5,5,5,3,3,3,3,3,1,1,1,3,5,3,3,1,1,1,1,1,1,1,3,3,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,1,1,1,1,2,2,2,4,1,1,2,2,2,2,4,4,2,1,1,2,2,2,2,2,2,4,4,2,4,2,2,2,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
char f04[] = {2,1,1,2,2,2,1,1,2,2,2,2,2,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,1,1,2,2,2,2,2,1,1,2,2,1,1,1,1,2,2,2,2,0,0,3,3,0,0,0,3,3,3,3,0,0,0,3,3,3,0,0,0,3,3,3,3,3,0,0,0,0,0,0,0,0};
char f05[] = {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,3,4,4,4,4,5,5,5,5,5,5,5,5};
char f06[] = {1,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2};
char f07[] = {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2};
char f08[] = {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
char f09[] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
char f0a[] = {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
char *fux[] = {f00, f01, f02, f03, f04, f05, f06, f07, f08, f09, f0a};

// Opisy fuse/lock bitw
char *fna[] = {"Reserved","SPIEN","EESAVE","WDTON","CKDIV8","SUT1","SUT0","CKSEL1","CKSEL0","CKOUT","CKSEL3","CKSEL2","PLLCK","CKOPT","BODLEVEL","BODEN","SUT","RSTDISBL","RCEN","DWEN","SELFPRGEN","SUT2","OSCSEL1","OSCSEL0","OSCSEL","BOOTRST","FSTRT","BODLEVEL2","BODLEVEL1","BODLEVEL0","INTCAP","BOOTSZ1","BOOTSZ0","CKSEL","JTAGUID7","JTAGUID6","JTAGUID5","JTAGUID4","JTAGUID3","JTAGUID2","JTAGUID1","JTAGUID0","WINDOW3","WINDOW2","WINDOW1","WINDOW0","PERIOD3","PERIOD2","PERIOD1","PERIOD0","OCDEN","JTAGEN","S8515C","S8535C","COMPMODE","WDWPER3","WDWPER2","WDWPER1","WDWPER0","WDPER3","WDPER2","WDPER1","WDPER0","LVL2","LVL1","LVL0","SAMPFREQ","ACTIVE1","ACTIVE0","SLEEP1","SLEEP0","M103C","M161C","ULPOSCSEL2","ULPOSCSEL1","ULPOSCSEL0","BODPD1","BODPD0","BODACT1","BODACT0","PSC2RB","PSC1RB","PSC0RB","PSCRV","PSC2RBA","PSCRRB","PSCINRB","HWBE","PSCRB","PSCRVA","PSCRVB","CFD","TOSCSEL","OSCLOCK","FREQSEL1","FREQSEL0","LB2","LB1","BLB12","BLB11","BLB02","BLB01","NVLB2","NVLB1","STARTUPTIME1","STARTUPTIME0","WDLOCK","CMPDEN","CMPCEN","CMPBEN","CMPAEN","CMPD","CMPC","CMPB","CMPA","CRCSRC1","CRCSRC0","RSTPINCFG1","RSTPINCFG0","TOUTDIS","RSTPINCFG","FDACT5","FDACT4","VALUE5","VALUE4","VALUE3","VALUE2","VALUE1","VALUE0","BLBB1","BLBB0","BLBA1","BLBA0","BLBAT1","BLBAT0","LB0","APPEND7","APPEND6","APPEND5","APPEND4","APPEND3","APPEND2","APPEND1","APPEND0","BOOTEND7","BOOTEND6","BOOTEND5","BOOTEND4","BOOTEND3","BOOTEND2","BOOTEND1","BOOTEND0","LOCKBIT7","LOCKBIT6","LOCKBIT5","LOCKBIT4","LOCKBIT3","LOCKBIT2","LOCKBIT1","LOCKBIT0"};
char *fde[] = {"","Serial Programming enable","Save EEPROM memory during Chip Erase","Watchdog Timer always on","Divide Clock by 8","Select Start-up time","Select Clock source","Clock Output enable","Use PLL for internal clock","Oscillator Options","Brown-out Detector trigger level","Brown-out Detector enable","System Start-up time","External Reset disable","Internal RC Oscillator enable","debugWire enable","Self Programming enable","Oscillator Select","Select Reset vector","Short Start-up time enable","Internal XTAL1/2 Capacitors enable","Select Boot size","Clock Selection","JTAG Interface user ID","Watchdog Window time-out period","Watchdog Time-out period","On-chip Debugger enable","JTAG Interface enable","AT90S4414/8515 Compatibility mode","AT90S8535 Compatibility mode","Compatibility mode","Brown-out Detector sample frequency","BOD Mode when device is active or idle","BOD Mode when device is sleep","ATmega103 Compatibility mode","ATmega161 Compatibility mode","Select Internal ULP oscillator frequency","PSC2 Reset behaviour","PSC1 Reset behaviour","PSC0 Reset behaviour","PSCOUT Reset value","PSC2 Reset behaviour for OUT22/23","PSC Reduced Reset behaviour","PSCOUT/PSCOUTR Reset value","PSC/PSCR Inputs Reset behaviour","Hardware Boot enable","PSC Reset behaviour","PSCOUTnA Reset value","PSCOUTnB Reset value","Clock Failure Detection disable","32kHz Timer Oscillator pin select","Oscillator Lock","Frequency Select","Lock Bit","Boot Lock Bit","Non-Volatile Lock Bit","Watchdog Timer lock","Compare D Output pin enable","Compare C Output pin enable","Compare B Output pin enable","Compare A Output pin enable","Compare D default state","Compare C default state","Compare B default state","Compare A default state","CRC Source","Reset Pin configuration","Time-Out disable","Fault Detection action on TC5","Fault Detection action on TC4","Port Pin output value","Boot Lock Bit boot loader section","Boot Lock Bit application section","Boot Lock Bit application table section","Application Code section end","Boot Loader section end"};
char fu0[] = {106,1,1,2,2,3,3,4,4,5,5,6,5,7,6,8,6,98,4,4,9,7,5,5,6,5,10,6,11,6,7,6,8,6,225,12,8,13,9,5,5,6,5,10,6,11,6,7,6,8,6,110,4,4,9,7,5,5,6,5,0,0,0,0,7,6,8,6,100,4,4,9,7,5,5,6,5,10,6,11,6,7,6,8,6,225,14,10,15,11,5,5,6,5,10,6,11,6,7,6,8,6,98,4,4,9,7,0,0,16,12,10,6,11,6,7,6,8,6,94,4,4,9,7,5,5,6,5,10,6,11,6,7,6,8,6,82,14,10,15,11,1,1,17,13,10,6,11,6,7,6,8,6,92,14,10,15,11,1,1,17,13,0,0,0,0,7,6,8,6,222,0,0,0,0,1,1,0,0,0,0,0,0,0,0,18,14,223,3,3,2,2,1,1,19,15,20,16,21,5,5,5,6,5,82,4,4,9,7,5,5,6,5,10,6,11,6,7,6,8,6,221,3,3,2,2,1,1,21,5,5,5,6,5,22,17,23,17,215,3,3,2,2,1,1,15,11,4,4,5,5,6,5,24,17,223,0,0,0,0,1,1,0,0,2,2,0,0,5,5,6,5,234,0,0,0,0,25,18,1,1,16,5,11,6,7,6,8,6,210,14,10,15,11,1,1,0,0,10,6,11,6,7,6,8,6,242,14,10,15,11,0,0,0,0,10,6,11,6,7,6,8,6,223,0,0,0,0,1,1,0,0,0,0,0,0,0,0,18,14,223,0,0,0,0,1,1,0,0,0,0,0,0,0,0,26,19,222,0,0,0,0,1,1,0,0,0,0,0,0,0,0,26,19,218,0,0,0,0,1,1,14,10,15,11,11,6,7,6,8,6,255,0,0,0,0,0,0,0,0,0,0,9,7,3,3,17,13,252,0,0,0,0,0,0,26,19,17,13,11,6,7,6,8,6,255,0,0,27,10,28,10,29,10,0,0,9,7,3,3,17,13,242,0,0,0,0,0,0,30,20,10,6,11,6,7,6,8,6,205,3,3,2,2,31,21,32,21,25,18,5,5,6,5,33,22,255,0,0,0,0,0,0,0,0,20,16,9,7,3,3,17,13,255,34,23,35,23,36,23,37,23,38,23,39,23,40,23,41,23,0,42,24,43,24,44,24,45,24,46,25,47,25,48,25,49,25};
char fu1[] = {255,0,0,0,0,0,0,20,16,19,15,28,10,29,10,17,13,223,17,13,19,15,1,1,3,3,2,2,27,10,28,10,29,10,247,0,0,0,0,0,0,17,13,1,1,2,2,14,10,15,11,223,19,15,2,2,1,1,3,3,27,10,28,10,29,10,17,13,217,17,13,3,3,1,1,13,9,2,2,31,21,32,21,25,18,153,50,26,51,27,1,1,13,9,2,2,31,21,32,21,25,18,217,17,13,19,15,1,1,3,3,2,2,31,21,32,21,25,18,153,50,26,51,27,1,1,3,3,2,2,31,21,32,21,25,18,217,52,28,3,3,1,1,13,9,2,2,31,21,32,21,25,18,217,53,29,3,3,1,1,13,9,2,2,31,21,32,21,25,18,217,19,15,17,13,1,1,3,3,2,2,31,21,32,21,25,18,155,50,26,51,27,1,1,3,3,2,2,31,21,32,21,25,18,254,0,0,0,0,0,0,0,0,0,0,0,0,22,17,23,17,249,0,0,0,0,0,0,0,0,0,0,54,30,22,17,23,17,233,0,0,0,0,0,0,4,4,19,15,31,21,32,21,25,18,249,0,0,0,0,0,0,0,0,19,15,31,21,32,21,25,18,249,0,0,0,0,0,0,0,0,0,0,31,21,32,21,25,18,153,50,26,51,27,1,1,0,0,2,2,31,21,32,21,25,18,254,0,0,0,0,0,0,0,0,0,0,0,0,50,26,51,27,0,55,24,56,24,57,24,58,24,59,25,60,25,61,25,62,25,0,63,10,64,10,65,10,66,31,67,32,68,32,69,33,70,33};
char fu2[] = {255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,20,16,249,0,0,0,0,0,0,0,0,0,0,31,21,32,21,25,18,255,0,0,0,0,0,0,0,0,0,0,27,10,28,10,29,10,253,0,0,0,0,0,0,0,0,0,0,0,0,71,34,3,3,255,0,0,0,0,0,0,72,35,27,10,28,10,29,10,0,0,255,0,0,0,0,0,0,0,0,27,10,28,10,29,10,0,0,255,0,0,0,0,0,0,0,0,27,10,28,10,29,10,17,13,255,0,0,0,0,0,0,0,0,0,0,28,10,29,10,17,13,255,73,36,74,36,75,36,76,33,77,33,78,32,79,32,20,16,255,76,33,77,33,78,32,79,32,0,0,31,21,32,21,25,18,255,0,0,0,0,0,0,76,33,77,33,78,32,79,32,20,16,249,80,37,81,38,82,39,83,40,0,0,31,21,32,21,25,18,253,80,37,84,41,85,42,83,43,86,44,27,10,28,10,29,10,244,0,0,0,0,0,0,0,0,87,45,27,10,28,10,29,10,243,0,0,0,0,0,0,0,0,87,45,27,10,28,10,29,10,255,0,0,0,0,88,46,89,47,90,48,27,10,28,10,29,10,251,0,0,0,0,0,0,0,0,87,45,27,10,28,10,29,10,247,0,0,0,0,0,0,0,0,91,49,27,10,28,10,29,10,7,0,0,0,0,0,0,0,0,91,49,27,10,28,10,29,10,254,0,0,0,0,0,0,0,0,0,0,27,10,28,10,29,10,255,0,0,25,18,0,0,0,0,0,0,0,0,76,33,77,33,255,0,0,25,18,92,50,0,0,0,0,0,0,76,33,77,33,2,93,51,0,0,0,0,0,0,0,0,0,0,94,52,95,52};
char fu3[] = {255,0,0,0,0,0,0,0,0,0,0,0,0,96,53,97,53,255,0,0,0,0,98,54,99,54,100,54,101,54,96,53,97,53,255,0,0,0,0,0,0,0,0,0,0,97,53,96,53,0,0,236,0,0,0,0,98,54,99,54,100,54,101,54,96,53,97,53,255,0,0,0,0,0,0,0,0,0,0,0,0,102,55,103,55};
char fu4[] = {254,0,0,0,0,0,0,17,13,104,5,105,5,106,56,51,27,255,0,0,0,0,0,0,17,13,104,5,105,5,106,56,0,0,0,107,57,108,58,109,59,110,60,111,61,112,62,113,63,114,64};
char fu5[] = {255,0,0,0,0,78,32,79,32,2,2,27,10,28,10,29,10,196,115,65,116,65,0,0,0,0,117,66,118,66,0,0,2,2,230,115,65,116,65,0,0,0,0,117,66,118,66,0,0,2,2,246,115,65,116,65,0,0,119,67,117,66,118,66,0,0,2,2,192,115,65,116,65,0,0,0,0,120,66,0,0,0,0,2,2};
char fu6[] = {255,121,68,122,69,123,70,124,70,125,70,126,70,127,70,128,70,7,0,0,0,0,0,0,0,0,0,0,21,5,5,5,6,5};
char fu7[] = {255,129,71,130,71,131,72,132,72,133,73,134,73,97,53,135,53,0,136,74,137,74,138,74,139,74,140,74,141,74,142,74,143,74};
char fu8[] = {0,144,75,145,75,146,75,147,75,148,75,149,75,150,75,151,75};
char fu9[] = {0};
char fua[] = {197,152,53,153,53,154,53,155,53,156,53,157,53,158,53,159,53};
char *fuy[] = {fu0, fu1, fu2, fu3, fu4, fu5, fu6, fu7, fu8, fu9, fua};

/* Krok 4: procedura gwnego okna programu */
LRESULT CALLBACK WndProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
switch(Message)
 {
// Tworzenie zawartoci gwnego okna programu
 case WM_CREATE:
 hFont = GetStockObject(DEFAULT_GUI_FONT); // Domylna czcionka systemu Windows

// Panel zakadek
 icx.dwICC = ICC_TAB_CLASSES;
 icx.dwSize = sizeof(INITCOMMONCONTROLSEX);
 InitCommonControlsEx(&icx);
 tci.mask = TCIF_TEXT;
 hTab0 = CreateWindow(WC_TABCONTROL, 0, WS_CHILD | WS_VISIBLE | WS_TABSTOP | TCS_FOCUSONBUTTONDOWN, 5, 5, winx-16, winy-76, hwnd, 0, hInst, 0);
 SendMessage(hTab0, WM_SETFONT, hFont, 0);
 SendMessage(hTab0, TCM_SETMINTABWIDTH, 0, 24); // Ustawienie minimalnej szerokoci nazwy zakadki

// Rozwijalna lista "Select"
 hWin0 = CreateWindow("STATIC", "Select:", WS_CHILD | WS_VISIBLE, 13, 44, 38, 17, hwnd, 0, hInst, 0);
 SendMessage(hWin0, WM_SETFONT, hFont, 0);
 hLis0 = CreateWindow("COMBOBOX", 0, WS_CHILD | WS_VISIBLE | WS_TABSTOP | WS_VSCROLL | CBS_DROPDOWNLIST , 52, 40, 155, 250, hwnd, 0, hInst, 0);
 SendMessage(hLis0, WM_SETFONT, hFont, 0);
 hTemp = hLis0;

// Przycisk "Save list..."
 hBut5 = CreateWindow("BUTTON", "Save list...", WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_PUSHBUTTON | BS_NOTIFY, 232, 40, 60, 21, hwnd, ID_SAVELIST, hInst, 0);
 SendMessage(hBut5, WM_SETFONT, hFont, 0);

// Grupa "Informations"
 hBut0 = CreateWindow("BUTTON", " Informations ", WS_CHILD | WS_VISIBLE | BS_GROUPBOX, 52, 73, 348, 189, hwnd, 0, hInst, 0);
 SendMessage(hBut0, WM_SETFONT, hFont, 0);
 hWin1 = CreateWindow("STATIC", "", WS_CHILD | WS_VISIBLE, 63, 93, 328, 160, hwnd, 0, hInst, 0);
 SendMessage(hWin1, WM_SETFONT, hFont, 0);

// Dodatkowe okno informacyjne
 hWin2 = CreateWindow("STATIC", "", WS_CHILD | WS_VISIBLE, 13, 277, 428, 105, hwnd, 0, hInst, 0);
 SendMessage(hWin2, WM_SETFONT, hFont, 0);

// Dodawanie wszystkich ukadw do listy
 for(csel=0; csel<chip; csel=csel+1)
  {sprintf(smsg, "%s%s", nap[nax[csel]], nam[csel]);
   SendMessage(hLis0, CB_ADDSTRING, 0, smsg);} // Dodanie pozycji z nazw ukadu do listy
 SendMessage(hLis0, CB_SETCURSEL, 0, 0); // Wybranie pozycji 0 z listy
 SendMessage(hwnd, WM_COMMAND, MAKELONG(0, CBN_SELCHANGE), 0); // Wysanie komunikatu o zmianie pozycji na licie

// Okna z numerami fuse/lock bitw
 hFun7 = CreateWindow("STATIC", "Bit 7", WS_CHILD, 22, 63, 25, 17, hwnd, 0, hInst, 0);
 SendMessage(hFun7, WM_SETFONT, hFont, 0);
 hFun6 = CreateWindow("STATIC", "Bit 6", WS_CHILD, 22, 93, 25, 17, hwnd, 0, hInst, 0);
 SendMessage(hFun6, WM_SETFONT, hFont, 0);
 hFun5 = CreateWindow("STATIC", "Bit 5", WS_CHILD, 22, 123, 25, 17, hwnd, 0, hInst, 0);
 SendMessage(hFun5, WM_SETFONT, hFont, 0);
 hFun4 = CreateWindow("STATIC", "Bit 4", WS_CHILD, 22, 153, 25, 17, hwnd, 0, hInst, 0);
 SendMessage(hFun4, WM_SETFONT, hFont, 0);
 hFun3 = CreateWindow("STATIC", "Bit 3", WS_CHILD, 22, 183, 25, 17, hwnd, 0, hInst, 0);
 SendMessage(hFun3, WM_SETFONT, hFont, 0);
 hFun2 = CreateWindow("STATIC", "Bit 2", WS_CHILD, 22, 213, 25, 17, hwnd, 0, hInst, 0);
 SendMessage(hFun2, WM_SETFONT, hFont, 0);
 hFun1 = CreateWindow("STATIC", "Bit 1", WS_CHILD, 22, 243, 25, 17, hwnd, 0, hInst, 0);
 SendMessage(hFun1, WM_SETFONT, hFont, 0);
 hFun0 = CreateWindow("STATIC", "Bit 0", WS_CHILD, 22, 273, 25, 17, hwnd, 0, hInst, 0);
 SendMessage(hFun0, WM_SETFONT, hFont, 0);

// Przyciski z wartociami fuse/lock bitw
 hFub7 = CreateWindow("BUTTON", "", WS_CHILD | WS_TABSTOP | BS_PUSHBUTTON | BS_NOTIFY, 53, 60, 21, 20, hwnd, ID_FUS7, hInst, 0);
 SendMessage(hFub7, WM_SETFONT, hFont, 0);
 hFub6 = CreateWindow("BUTTON", "", WS_CHILD | WS_TABSTOP | BS_PUSHBUTTON | BS_NOTIFY, 53, 90, 21, 20, hwnd, ID_FUS6, hInst, 0);
 SendMessage(hFub6, WM_SETFONT, hFont, 0);
 hFub5 = CreateWindow("BUTTON", "", WS_CHILD | WS_TABSTOP | BS_PUSHBUTTON | BS_NOTIFY, 53, 120, 21, 20, hwnd, ID_FUS5, hInst, 0);
 SendMessage(hFub5, WM_SETFONT, hFont, 0);
 hFub4 = CreateWindow("BUTTON", "", WS_CHILD | WS_TABSTOP | BS_PUSHBUTTON | BS_NOTIFY, 53, 150, 21, 20, hwnd, ID_FUS4, hInst, 0);
 SendMessage(hFub4, WM_SETFONT, hFont, 0);
 hFub3 = CreateWindow("BUTTON", "", WS_CHILD | WS_TABSTOP | BS_PUSHBUTTON | BS_NOTIFY, 53, 180, 21, 20, hwnd, ID_FUS3, hInst, 0);
 SendMessage(hFub3, WM_SETFONT, hFont, 0);
 hFub2 = CreateWindow("BUTTON", "", WS_CHILD | WS_TABSTOP | BS_PUSHBUTTON | BS_NOTIFY, 53, 210, 21, 20, hwnd, ID_FUS2, hInst, 0);
 SendMessage(hFub2, WM_SETFONT, hFont, 0);
 hFub1 = CreateWindow("BUTTON", "", WS_CHILD | WS_TABSTOP | BS_PUSHBUTTON | BS_NOTIFY, 53, 240, 21, 20, hwnd, ID_FUS1, hInst, 0);
 SendMessage(hFub1, WM_SETFONT, hFont, 0);
 hFub0 = CreateWindow("BUTTON", "", WS_CHILD | WS_TABSTOP | BS_PUSHBUTTON | BS_NOTIFY, 53, 270, 21, 20, hwnd, ID_FUS0, hInst, 0);
 SendMessage(hFub0, WM_SETFONT, hFont, 0);

// Okna z nazwami/opisami fuse/lock bitw
 hFuw7 = CreateWindow("STATIC", "", WS_CHILD, 82, 63, 358, 17, hwnd, 0, hInst, 0);
 SendMessage(hFuw7, WM_SETFONT, hFont, 0);
 hFuw6 = CreateWindow("STATIC", "", WS_CHILD, 82, 93, 358, 17, hwnd, 0, hInst, 0);
 SendMessage(hFuw6, WM_SETFONT, hFont, 0);
 hFuw5 = CreateWindow("STATIC", "", WS_CHILD, 82, 123, 358, 17, hwnd, 0, hInst, 0);
 SendMessage(hFuw5, WM_SETFONT, hFont, 0);
 hFuw4 = CreateWindow("STATIC", "", WS_CHILD, 82, 153, 358, 17, hwnd, 0, hInst, 0);
 SendMessage(hFuw4, WM_SETFONT, hFont, 0);
 hFuw3 = CreateWindow("STATIC", "", WS_CHILD, 82, 183, 358, 17, hwnd, 0, hInst, 0);
 SendMessage(hFuw3, WM_SETFONT, hFont, 0);
 hFuw2 = CreateWindow("STATIC", "", WS_CHILD, 82, 213, 358, 17, hwnd, 0, hInst, 0);
 SendMessage(hFuw2, WM_SETFONT, hFont, 0);
 hFuw1 = CreateWindow("STATIC", "", WS_CHILD, 82, 243, 358, 17, hwnd, 0, hInst, 0);
 SendMessage(hFuw1, WM_SETFONT, hFont, 0);
 hFuw0 = CreateWindow("STATIC", "", WS_CHILD, 82, 273, 358, 17, hwnd, 0, hInst, 0);
 SendMessage(hFuw0, WM_SETFONT, hFont, 0);

// Okna z wartoci fuse/lock bitw
 hFuv0 = CreateWindow("STATIC", "Value:", WS_CHILD, 15, 310, 35, 17, hwnd, 0, hInst, 0);
 SendMessage(hFuv0, WM_SETFONT, hFont, 0);
 hFuv1 = CreateWindow("STATIC", "", WS_CHILD | SS_SUNKEN | SS_CENTER, 53, 309, 24, 17, hwnd, 0, hInst, 0);
 SendMessage(hFuv1, WM_SETFONT, hFont, 0);
 hFuv2 = CreateWindow("STATIC", "(default)", WS_CHILD, 85, 310, 45, 17, hwnd, 0, hInst, 0);
 SendMessage(hFuv2, WM_SETFONT, hFont, 0);

// Przyciski gwnego okna programu
 hBut1 = CreateWindow("BUTTON", "Save info...", WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_PUSHBUTTON | BS_NOTIFY, 12, 409, 90, 25, hwnd, ID_SAVE, hInst, 0);
 SendMessage(hBut1, WM_SETFONT, hFont, 0);
 hBut2 = CreateWindow("BUTTON", "Interfaces...", WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_PUSHBUTTON | BS_NOTIFY, 125, 409, 90, 25, hwnd, ID_INFO, hInst, 0);
 SendMessage(hBut2, WM_SETFONT, hFont, 0);
 hBut3 = CreateWindow("BUTTON", "About...", WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_PUSHBUTTON | BS_NOTIFY, 238, 409, 90, 25, hwnd, ID_ABOUT, hInst, 0);
 SendMessage(hBut3, WM_SETFONT, hFont, 0);
 hBut4 = CreateWindow("BUTTON", "Quit", WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_PUSHBUTTON | BS_NOTIFY, 351, 409, 90, 25, hwnd, ID_QUIT, hInst, 0);
 SendMessage(hBut4, WM_SETFONT, hFont, 0);
 break;

// Obsuga odbieranych rozkazw
 case WM_COMMAND:
 switch(HIWORD(wParam))
  {
  case 0:
  switch(LOWORD(wParam))
   {
// Wybranie przycisku "Save list..."
   case ID_SAVELIST:
   sprintf(fnam, "%s", "AVRdb_Chips_List"); // Domylna nazwa pliku wyjciowego z list obsugiwanych ukadw
   if(FileSelect()) // Wskazano plik w oknie wyboru do zapisu listy obsugiwanych ukadw
    {hFile = CreateFile(fnam, GENERIC_WRITE, 0, 0, CREATE_ALWAYS, 0, 0);
     if(hFile==INVALID_HANDLE_VALUE) goto Z; // Nie mona otworzy pliku do zapisu
// Zapisywanie informacji nagwkowych
     sprintf(smsg, "%s supports %d chips:\r\n\r\n", snam, chip);
     if(!WriteFile(hFile, smsg, strlen(smsg), &fsih, 0)) goto B; // Nie mona zapisa danych do pliku
     if(strlen(smsg)!=fsih) goto B; // Nie zapisano wszystkich danych do pliku
// Zapisywanie nazw wszystkich obsugiwanych ukadw
   for(xsel=0; xsel<chip; xsel=xsel+1)
    {sprintf(smsg, "%s%s\r\n", nap[nax[xsel]], nam[xsel]); // Nazwa ukadu
     if(!WriteFile(hFile, smsg, strlen(smsg), &fsih, 0)) goto B; // Nie mona zapisa danych do pliku
     if(strlen(smsg)!=fsih) goto B;} // Nie zapisano wszystkich danych do pliku
     CloseHandle(hFile);} // Zamknicie otwartego pliku
   break;

// Wybranie przycisku "Save info..."
   case ID_SAVE:
   SendMessage(hLis0, CB_GETLBTEXT, csel, fnam); // Domylna nazwa pliku wyjciowego z informacjami o wybranym ukadzie (nazwa pozycji z listy)
   if(FileSelect()) // Wskazano plik w oknie wyboru do zapisu informacji o wybranym ukadzie
    {hFile = CreateFile(fnam, GENERIC_WRITE, 0, 0, CREATE_ALWAYS, 0, 0);
     if(hFile==INVALID_HANDLE_VALUE) // Nie mona otworzy pliku do zapisu
Z:    {sprintf(smsg, "Can't open this file for write.\nMaybe it is used by other program.");
A:     MessageBox(hwnd, smsg, "Error saving file", MB_ICONERROR);
       break;}
// Zapisywanie informacji o wybranym ukadzie
     if(!WriteFile(hFile, smsi, strlen(smsi), &fsih, 0)) // Nie mona zapisa danych do pliku
B:    {sprintf(smsg, "Can't write data to this file.\nMaybe disk has read/write errors.");
       CloseHandle(hFile); // Zamknicie otwartego pliku
       goto A;}
     if(strlen(smsi)!=fsih) goto B; // Nie zapisano wszystkich danych do pliku
// Zapisywanie informacji o fuse/lock bitach wybranego ukadu
     if(!WriteFile(hFile, smsj, strlen(smsj), &fsih, 0)) goto B; // Nie mona zapisa danych do pliku
     if(strlen(smsj)!=fsih) goto B; // Nie zapisano wszystkich danych do pliku
     CloseHandle(hFile);} // Zamknicie otwartego pliku
   break;

// Wybranie przycisku "Interfaces..."
   case ID_INFO:
   MessageBox(hwnd, info, "Interfaces...", MB_ICONINFORMATION); // Wywietlanie informacji o interfejsach
   break;

// Wybranie przycisku "About..."
   case ID_ABOUT:
   MessageBox(hwnd, sver, "About...", MB_ICONINFORMATION); // Wywietlanie informacji o programie
   break;

// Wybranie przycisku "Quit"
   case ID_QUIT:
   SendMessage(hwnd, WM_DESTROY, 0, 0);
   break;
   
// Wybranie przycisku z wartoci fuse/lock bitu nr 7-0
   case ID_FUS7:
   xsel = 7; // Numer bitu do zmiany w aktualnej wartoci fuse/lock bitw
   goto C;
   case ID_FUS6:
   xsel = 6; // Numer bitu do zmiany w aktualnej wartoci fuse/lock bitw
   goto C;
   case ID_FUS5:
   xsel = 5; // Numer bitu do zmiany w aktualnej wartoci fuse/lock bitw
   goto C;
   case ID_FUS4:
   xsel = 4; // Numer bitu do zmiany w aktualnej wartoci fuse/lock bitw
   goto C;
   case ID_FUS3:
   xsel = 3; // Numer bitu do zmiany w aktualnej wartoci fuse/lock bitw
   goto C;
   case ID_FUS2:
   xsel = 2; // Numer bitu do zmiany w aktualnej wartoci fuse/lock bitw
   goto C;
   case ID_FUS1:
   xsel = 1; // Numer bitu do zmiany w aktualnej wartoci fuse/lock bitw
   goto C;
   case ID_FUS0:
   xsel = 0; // Numer bitu do zmiany w aktualnej wartoci fuse/lock bitw
C: fdef[0] ^= 1<<xsel; // Zmiana wartoci bitu w aktualnej wartoci fuse/lock bitw
   SendMessage(hTemp, WM_GETTEXT, 2, smsg); // Nazwa uytego przycisku fuse/lock bitu
   if(smsg[0]==49) SendMessage(hTemp, WM_SETTEXT, 0, "0"); else SendMessage(hTemp, WM_SETTEXT, 0, "1"); // Zmiana nazwy uytego przycisku fuse/lock bitu
   sprintf(smsg, "%02X", fdef[0]); // Cig tekstowy z aktualn wartoci fuse/lock bitw
   SendMessage(hFuv1, WM_SETTEXT, 0, smsg);
   if(fdef[0] == cfus[0]) EnableWindow(hFuv2, 1); else EnableWindow(hFuv2, 0); // Odblokowanie/zablokowanie okna z napisem "(default)"
   break;
   }
  break;

// Wybranie pozycji z listy "Select"
  case CBN_SELCHANGE:
  csel = SendMessage(hLis0, CB_GETCURSEL, 0, 0); // Numer aktualnie wybranej pozycji (ukadu) z listy
// Obsuga zakadek panelu
  SendMessage(hTab0, TCM_DELETEALLITEMS, 0, 0); // Usuwanie wszystkich zakadek z panelu
  tci.pszText = "Chip";
  SendMessage(hTab0, TCM_INSERTITEM, 0, &tci); // Dodanie zakadki "Chip" do panelu
// Liczba zakadek fuse/lock bitw dla wybranego z listy ukadu
  tnum = 4; // Zwyky ukad AT90/ATtiny/ATmega (3x fuse + lock)
  if(nax[csel]==3) tnum = 8; // Ukad ATxmega z interfejsem PDI (7x fuse + lock)
  if(strstr(fac[fax[csel]], "UPDI")) tnum = 11; // Nowy ukad ATtiny/ATmega z interfejsem UPDI (10x fuse + lock)
// Dodawanie zakadek fuse/lock bitw dla wybranego z listy ukadu
  for(ctab=0; ctab<tnum; ctab=ctab+1)
   {if(tnum==4) sprintf(smsg, "Fuse %s", fus[ctab]); else sprintf(smsg, "Fuse %d", ctab); // Nazwa zakadki fuse bitw
    if(ctab==tnum-1) sprintf(smsg, "%s", fus[3]); // Nazwa zakadki lock bitw
    xsel = 0;
    if(ctab>3)
     {if(ctab>7) xsel = cupd; else xsel = cpdi;}
    if(!fux[ctab][csel-xsel]) sprintf(smsg, "---"); // Nazwa zakadki fuse bitw zastrzeonych (Reserved) w wybranym ukadzie
    tci.pszText = smsg; // Cig tekstowy z nazw zakadki
    SendMessage(hTab0, TCM_INSERTITEM, ctab+1, &tci);} // Dodanie zakadki fuse/lock bitw do panelu
  RedrawWindow(hwnd, 0, 0, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ALLCHILDREN); // Odwieenie gwnego okna programu
// Wywietlenie informacji o wybranym z listy ukadzie
  sprintf(smsg, "FLASH: %d bytes (page size %d bytes)\r\nEEPROM: %d bytes (page size %d bytes)\r\nSRAM: %d bytes\r\n\r\nSignature: 1E%4X\r\nCalibration: %d byte(s)\r\n\r\nFmax: %d.%d MHz\r\nVcc: %d.%d-%d.%d V\r\n\r\nInterface(s): %s\r\nPackage(s): %s", fla[csel]*16, flp[csel]*4, epr[csel]*16, epp[csel]*4, sra[csel]*16, sig[csel], cal[csel], fra[csel], frb[csel], via[csel], vib[csel], vma[csel], vmb[csel], fac[fax[csel]], pac[pax[csel]]);
  SendMessage(hWin1, WM_SETTEXT, 0, smsg);
  SendMessage(hLis0, CB_GETLBTEXT, csel, fnam); // Domylna nazwa pliku wyjciowego z informacjami o wybranym ukadzie (nazwa pozycji z listy)
// Wywietlenie dodatkowych informacji
  switch(six[csel])
   {case 0: smsi[0] = 0; break;
    case 1: sprintf(smsi, "%s", txt[4]); break;
    case 2: sprintf(smsi, "%s%s%s", txt[1], txt[2], txt[4]); break;
    case 3: sprintf(smsi, "%s%s", txt[2], txt[4]); break;
    case 4: sprintf(smsi, "%s%s", txt[3], txt[4]); break;
    case 5: sprintf(smsi, "%s", txt[3]); break;
    case 6: sprintf(smsi, "%s17-bit).\r\n%s%s14.3 MHz).\r\n\r\n", txt[5], txt[9], txt[13]); break;
    case 7: sprintf(smsi, "%s10-bit).\r\n%s25.6 MHz).\r\n\r\n", txt[5], txt[13]); break;
    case 8: sprintf(smsi, "%s%s48 MHz).\r\n\r\n%s", txt[7], txt[13], txt[3]); break;
    case 9: sprintf(smsi, "%s10-bit).\r\n%s32-64 MHz).\r\n\r\n%s", txt[5], txt[13], txt[3]); break;
    case 10: sprintf(smsi, "%s10-bit).\r\n%s%s32-96 MHz).\r\n\r\n%s", txt[5], txt[7], txt[13], txt[3]); break;
    case 11: sprintf(smsi, "%s10-bit).\r\n%s%s", txt[5], txt[14], txt[3]); break;
    case 12: sprintf(smsi, "%s12-bit).\r\n%s/32).\r\n%s20-128 MHz).\r\n\r\n", txt[5], txt[12], txt[13]); break;
    case 13: sprintf(smsi, "%s12-bit).\r\n%s%s/32).\r\n%s20-128 MHz).\r\n\r\n", txt[5], txt[7], txt[12], txt[13]); break;
    case 14: sprintf(smsi, "%s10-bit).\r\n%s\r\n%s", txt[5], txt[8], txt[3]); break;
    case 15: sprintf(smsi, "%s10-bit).\r\n%s10-bit).\r\n%s%s%s32-64 MHz).\r\n\r\n%s", txt[5], txt[6], txt[8], txt[9], txt[13], txt[3]); break;
    case 16: sprintf(smsi, "%s10-bit).\r\n%s\r\n%s", txt[5], txt[9], txt[3]); break;
    case 17: sprintf(smsi, "%s10-bit).\r\n%s10-bit).\r\n%s%s\r\n%s", txt[5], txt[6], txt[8], txt[9], txt[3]); break;
    case 18: sprintf(smsi, "%s8-bit).\r\n\r\n", txt[5]); break;
    case 19: sprintf(smsi, "%s10-bit).\r\n\r\n", txt[5]); break;
    case 20: sprintf(smsi, "%s10-bit).\r\n\r\n%s%s", txt[5], txt[3], txt[4]); break;
    case 21: sprintf(smsi, "%s10-bit).\r\n%s%s48 MHz).\r\n\r\n%s", txt[5], txt[7], txt[13], txt[3]); break;
    case 22: sprintf(smsi, "%s10-bit).\r\n\r\n%s", txt[5], txt[3]); break;
    case 23: sprintf(smsi, "%s12-bit).\r\n\r\n%s", txt[5], txt[3]); break;
    case 24: sprintf(smsi, "%s12-bit).\r\n\r\n", txt[5]); break;
    case 25: sprintf(smsi, "%s10-bit).\r\n%s10-bit).\r\n%s32-64 MHz).\r\n\r\n%s", txt[5], txt[6], txt[13], txt[3]); break;
    case 26: sprintf(smsi, "%s12-bit).\r\n%s12-bit).\r\n%s4 channels).\r\n%s20-128 MHz).\r\n\r\n", txt[5], txt[6], txt[10], txt[13]); break;
    case 27: sprintf(smsi, "%s12-bit).\r\n%s12-bit).\r\n%s%s4 channels).\r\n%s/32).\r\n%s20-128 MHz).\r\n\r\n", txt[5], txt[6], txt[7], txt[10], txt[12], txt[13]); break;
    case 28: sprintf(smsi, "%s10-bit).\r\n%s8-bit).\r\n%sCCL).\r\n%s).\r\n\r\n", txt[5], txt[6], txt[11], txt[12]); break;
    case 29: sprintf(smsi, "%s12-bit).\r\n%s12-bit).\r\n%s4 channels).\r\n%sXCL).\r\n%s/32).\r\n%s20-128 MHz).\r\n\r\n", txt[5], txt[6], txt[10], txt[11], txt[12], txt[13]); break;
    case 30: sprintf(smsi, "%s10-bit).\r\n%sCCL).\r\n%s).\r\n\r\n", txt[5], txt[11], txt[12]); break;
    case 31: sprintf(smsi, "%s12-bit).\r\n%s%s2 channels).\r\n%s/32).\r\n%s20-128 MHz).\r\n\r\n", txt[5], txt[7], txt[10], txt[12], txt[13]); break;}
  if(flp[csel]==0 || epp[csel]==0) sprintf(smsh, "%s%s", smsi, txt[0]); else sprintf(smsh, "%s", smsi);
  SendMessage(hWin2, WM_SETTEXT, 0, smsh);
// Zapisanie wszystkich informacji do cigu tekstowego
  sprintf(smsi, "%s\r\n\r\n%s\r\n\r\n%s", fnam, smsg, smsh);
// Generowanie informacji o fuse/lock bitach wybranego z listy ukadu i zapisanie ich do cigu tekstowego
  sprintf(smsj, "##### Fuse/lock bits #####\r\n");
  for(ctab=0; ctab<tnum; ctab=ctab+1)
   {if(tnum==4) sprintf(smsg, "Fuse %s", fus[ctab]); else sprintf(smsg, "Fuse %d", ctab); // Nazwa aktualnych fuse bitw
    if(ctab==tnum-1) sprintf(smsg, "%s", fus[3]); // Nazwa aktualnych lock bitw
    xsel = 0;
    if(ctab>3)
     {if(ctab>7) xsel = cupd; else xsel = cpdi;}
    temp = fux[ctab][csel-xsel]; // Numer bloku danych opisujcych aktualne fuse/lock bity [17-bajtw]
    if(temp) // Aktualne fuse/lock bity s uywane w wybranym ukadzie
     {temp = temp-1;
      cfus = &fuy[ctab][temp*17]; // Adres bloku danych opisujcych aktualne fuse/lock bity [17-bajtw]
      sprintf(smsh, "\r\n%s: [%02X]\r\n", smsg, cfus[0]); // Nazwa i domylna warto aktualnych fuse/lock bitw
      strcat(smsj, smsh);
      for(xsel=0; xsel<8; xsel=xsel+1)
       {if((cfus[0] >> 7-xsel) & 1) fdef[0] = 1; else fdef[0] = 0; // Warto aktualnego fuse/lock bitu
        if(!cfus[xsel*2+1]) sprintf(smsg, "%s", fna[0]); // Aktualny fuse/lock bit jest zastrzeony (Reserved) - cig tekstowy z napisem "Reserved"
        else sprintf(smsg, "%s (%s)", fna[cfus[xsel*2+1]], fde[cfus[xsel*2+2]]); // Cigi tekstowe z nazw/opisem aktualnego fuse/lock bitu
        sprintf(smsh, "Bit %d: [%d] %s\r\n", 7-xsel, fdef[0], smsg);
        strcat(smsj, smsh);}}
    else // Aktualne fuse bity s zastrzeone (Reserved) w wybranym ukadzie
     {sprintf(smsh, "\r\n%s: [--] %s\r\n", smsg, fna[0]); // Nazwa aktualnych fuse/lock bitw i cig tekstowy z napisem "Reserved"
      strcat(smsj, smsh);}}
  break;

// Zaznaczenie przycisku "Save info...", "Interfaces...", "About...", "Quit" lub przycisku fuse/lock bitu (myszk lub klawiatur)
  case BN_SETFOCUS:
  hTemp = lParam;
  break;

// Zaznaczenie rozwijalnej listy (myszk lub klawiatur)
  case CBN_SETFOCUS:
  hTemp = lParam;
  break;
  }
 break;

// Obsuga powiadomie
 case WM_NOTIFY:
 lpn = (LPNMHDR)lParam;
 if(lpn->code == TCN_SELCHANGE && lpn->hwndFrom == hTab0) // Wybranie zakadki z panelu (myszk lub klawiatur)
  {ctab = SendMessage(hTab0, TCM_GETCURSEL, 0, 0); // Numer aktualnie wybranej zakadki z panelu
   switch(ctab)
    {case 0: ShowChip(); break; // Wybranie zakadki "Chip"
     default: ShowFuse();}} // Wybranie zakadki fuse/lock bitw
 break;

// Aktywacja gwnego okna programu
 case WM_SETFOCUS:
 SendMessage(hTemp, BM_SETSTYLE, BS_DEFPUSHBUTTON, 1); // Ustawienie ramki na ostatnio zaznaczonym przycisku
 SetFocus(hTemp); // Ustawienie fokusu na ostatnio zaznaczonym przycisku lub rozwijalnej licie
 break;

// Niszczenie gwnego okna programu
 case WM_DESTROY:
 PostQuitMessage(0);
 break;

 default:
 return DefWindowProc(hwnd, Message, wParam, lParam);
 }
return 0;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
MSG Msg;
WNDCLASSEX WndClass;
hInst = hInstance;
/* Krok 1: rejestrowanie klasy gwnego okna programu */
WndClass.cbSize        = sizeof(WNDCLASSEX);
WndClass.style         = 0;
WndClass.lpfnWndProc   = WndProc;
WndClass.cbClsExtra    = 0;
WndClass.cbWndExtra    = 0;
WndClass.hInstance     = hInst;
WndClass.hCursor       = LoadCursor(0, IDC_ARROW);
WndClass.hIcon         = LoadIcon(hInst, MAKEINTRESOURCE(ID_ICON));
WndClass.hIconSm       = 0;
WndClass.hbrBackground = (HBRUSH)COLOR_BTNSHADOW;
WndClass.lpszMenuName  = 0;
WndClass.lpszClassName = scla;
if(!RegisterClassEx(&WndClass))
 {MessageBox(0, "Window Registration Failed!", "Error!", MB_ICONERROR);
  return 0;}
// Centrowanie gwnego okna programu
scrx = GetSystemMetrics(SM_CXSCREEN); // Szeroko aktualnego ekranu
scry = GetSystemMetrics(SM_CYSCREEN); // Wysoko aktualnego ekranu
/* Krok 2: tworzenie gwnego okna programu */
hWnd = CreateWindowEx(WS_EX_ACCEPTFILES, scla, snam, WS_SYSMENU | WS_CAPTION | WS_MINIMIZEBOX, (scrx-winx)/2, (scry-winy)/2, winx, winy, 0, 0, hInst, 0);
if(!hWnd)
 {MessageBox(0, "Window Creation Failed!", "Error!", MB_ICONERROR);
  return 0;}
ShowWindow(hWnd, nCmdShow);
UpdateWindow(hWnd);
/* Krok 3: ptla wiadomoci gwnego okna programu */
  while(GetMessage(&Msg, 0, 0, 0) > 0)
   {if(!IsDialogMessage(hWnd, &Msg))
     {TranslateMessage(&Msg);
      DispatchMessage(&Msg);}}
return Msg.wParam;
}

// Funkcja wywietla/ukrywa kontrolki na zakadce "Chip"
void ShowChip()
{
ShowWindow(hWin0, 5); // Wywietlenie okna z napisem "Select:"
ShowWindow(hLis0, 5); // Wywietlenie rozwijalnej listy
ShowWindow(hBut5, 5); // Wywietlenie przycisku "Save list..."
ShowWindow(hBut0, 5); // Wywietlenie grupy "Informations"
ShowWindow(hWin1, 5); // Wywietlenie okna z informacjami o wybranym ukadzie
ShowWindow(hWin2, 5); // Wywietlenie dodatkowego okna z informacjami
// Ukrycie okien z numerami fuse/lock bitw
ShowWindow(hFun7, 0); ShowWindow(hFun6, 0); ShowWindow(hFun5, 0); ShowWindow(hFun4, 0); ShowWindow(hFun3, 0); ShowWindow(hFun2, 0); ShowWindow(hFun1, 0); ShowWindow(hFun0, 0);
// Ukrycie przyciskw z wartociami fuse/lock bitw
ShowWindow(hFub7, 0); ShowWindow(hFub6, 0); ShowWindow(hFub5, 0); ShowWindow(hFub4, 0); ShowWindow(hFub3, 0); ShowWindow(hFub2, 0); ShowWindow(hFub1, 0); ShowWindow(hFub0, 0);
// Ukrycie okien z nazwami/opisami fuse/lock bitw
ShowWindow(hFuw7, 0); ShowWindow(hFuw6, 0); ShowWindow(hFuw5, 0); ShowWindow(hFuw4, 0); ShowWindow(hFuw3, 0); ShowWindow(hFuw2, 0); ShowWindow(hFuw1, 0); ShowWindow(hFuw0, 0);
// Ukrycie okien z wartoci fuse/lock bitw
ShowWindow(hFuv0, 0); ShowWindow(hFuv1, 0); ShowWindow(hFuv2, 0);
}

// Funkcja wywietla/ukrywa kontrolki na zakadce fuse/lock bitw
void ShowFuse()
{
ShowWindow(hWin0, 0); // Ukrycie okna z napisem "Select:"
ShowWindow(hLis0, 0); // Ukrycie rozwijalnej listy
ShowWindow(hBut5, 0); // Ukrycie przycisku "Save list..."
ShowWindow(hBut0, 0); // Ukrycie grupy "Informations"
ShowWindow(hWin1, 0); // Ukrycie okna z informacjami o wybranym ukadzie
ShowWindow(hWin2, 0); // Ukrycie dodatkowego okna z informacjami
ctab = ctab-1;
xsel = 0;
if(ctab>3)
 {if(ctab>7) xsel = cupd; else xsel = cpdi;}
tnum = fux[ctab][csel-xsel]; // Numer bloku danych opisujcych aktualne fuse/lock bity [17-bajtw]
if(tnum) // Zakadka z fuse/lock bitami uywanymi w wybranym ukadzie
 {tnum = tnum-1;
  cfus = &fuy[ctab][tnum*17]; // Adres bloku danych opisujcych aktualne fuse/lock bity [17-bajtw]
  fdef[0] = cfus[0]; // Domylna warto aktualnych fuse/lock bitw
  for(xsel=0; xsel<8; xsel=xsel+1)
   {if((fdef[0] >> 7-xsel) & 1) SendMessage(*xFub[xsel], WM_SETTEXT, 0, "1"); else SendMessage(*xFub[xsel], WM_SETTEXT, 0, "0"); // Zmiana nazwy przycisku aktualnego fuse/lock bitu
    if(!cfus[xsel*2+1]) // Aktualny fuse/lock bit jest zastrzeony (Reserved)
     {sprintf(smsg, "%s", fna[0]); // Cig tekstowy z napisem "Reserved"
      SendMessage(*xFuw[xsel], WM_SETTEXT, 0, smsg);
      EnableWindow(*xFub[xsel], 0); // Zablokowanie przycisku z wartoci aktualnego fuse/lock bitu
      EnableWindow(*xFuw[xsel], 0);} // Zablokowanie okna z nazw/opisem aktualnego fuse/lock bitu
    else
     {sprintf(smsg, "%s (%s)", fna[cfus[xsel*2+1]], fde[cfus[xsel*2+2]]); // Cigi tekstowe z nazw/opisem aktualnego fuse/lock bitu
      SendMessage(*xFuw[xsel], WM_SETTEXT, 0, smsg);
      EnableWindow(*xFub[xsel], 1); // Odblokowanie przycisku z wartoci aktualnego fuse/lock bitu
      EnableWindow(*xFuw[xsel], 1);}} // Odblokowanie okna z nazw/opisem aktualnego fuse/lock bitu
  sprintf(smsg, "%02X", fdef[0]); // Cig tekstowy z domyln wartoci fuse/lock bitw
  SendMessage(hFuv1, WM_SETTEXT, 0, smsg);
  EnableWindow(hFuv1, 1); // Odblokowanie okna z domyln wartoci fuse/lock bitw
  EnableWindow(hFuv2, 1);} // Odblokowanie okna z napisem "(default)"
else // Zakadka z fuse bitami zastrzeonymi (Reserved) w wybranym ukadzie
 {for(xsel=0; xsel<8; xsel=xsel+1)
   {SendMessage(*xFub[xsel], WM_SETTEXT, 0, "-");
    sprintf(smsg, "%s", fna[0]); // Cig tekstowy z napisem "Reserved"
    SendMessage(*xFuw[xsel], WM_SETTEXT, 0, smsg);
    EnableWindow(*xFub[xsel], 0); // Zablokowanie przycisku z wartoci aktualnego fuse/lock bitu
    EnableWindow(*xFuw[xsel], 0);} // Zablokowanie okna z nazw/opisem aktualnego fuse/lock bitu
  SendMessage(hFuv1, WM_SETTEXT, 0, "--");
  EnableWindow(hFuv1, 0); // Zablokowanie okna z domyln wartoci fuse/lock bitw
  EnableWindow(hFuv2, 0);} // Zablokowanie okna z napisem "(default)"
// Wywietlenie okien z numerami fuse/lock bitw
ShowWindow(hFun7, 5); ShowWindow(hFun6, 5); ShowWindow(hFun5, 5); ShowWindow(hFun4, 5); ShowWindow(hFun3, 5); ShowWindow(hFun2, 5); ShowWindow(hFun1, 5); ShowWindow(hFun0, 5);
// Wywietlenie przyciskw z wartociami fuse/lock bitw
ShowWindow(hFub7, 5); ShowWindow(hFub6, 5); ShowWindow(hFub5, 5); ShowWindow(hFub4, 5); ShowWindow(hFub3, 5); ShowWindow(hFub2, 5); ShowWindow(hFub1, 5); ShowWindow(hFub0, 5);
// Wywietlenie okien z nazwami/opisami fuse/lock bitw
ShowWindow(hFuw7, 5); ShowWindow(hFuw6, 5); ShowWindow(hFuw5, 5); ShowWindow(hFuw4, 5); ShowWindow(hFuw3, 5); ShowWindow(hFuw2, 5); ShowWindow(hFuw1, 5); ShowWindow(hFuw0, 5);
// Wywietlenie okien z wartoci fuse/lock bitw
ShowWindow(hFuv0, 5); ShowWindow(hFuv1, 5); ShowWindow(hFuv2, 5);
}

// Funkcja wywietla okno wyboru pliku do zapisu
BOOL FileSelect()
{
ZeroMemory(&ofn, sizeof(ofn));
ofn.lStructSize = sizeof(ofn);
ofn.hwndOwner = hWnd;
ofn.lpstrFile = fnam; // Domylna nazwa pliku wyjciowego lub ostatnio uyta
ofn.lpstrTitle = "Save As...";
ofn.nMaxFile = MAX_PATH;
ofn.Flags = OFN_EXPLORER | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
ofn.lpstrFilter = "Text Files (*.txt)\0*.txt\0All Files (*.*)\0*.*\0\0";
ofn.lpstrDefExt = "txt";
if(!GetSaveFileName(&ofn)) return 0;
return 1;
}
